<?php

/**
 * My Application bootstrap file.
 */
// use Nette\Application\Routers\RouteList,
// 	Nette\Application\Routers\Route;
use Nette\Application\Routers\SimpleRouter;

// Load Nette Framework or autoloader generated by Composer
require LIBS_DIR . '/autoload.php';


// Configure application
$configurator = new Nette\Config\Configurator;

// Enable Nette Debugger for error visualisation & logging
$configurator->setDebugMode($configurator::AUTO);
$configurator->enableDebugger(__DIR__ . '/../log');

// Enable RobotLoader - this will load all classes automatically
$configurator->setTempDirectory(__DIR__ . '/../temp');
$configurator->createRobotLoader()
	->addDirectory(APP_DIR)
	->addDirectory(LIBS_DIR)
	->register();

// Create Dependency Injection container from config.neon file
$configurator->addConfig(__DIR__ . '/config/config.neon');
$container = $configurator->createContainer();

// Setup router
// $router = new RouteList; 
// $router[] = new Route('index.php', 'Homepage:default', Route::ONE_WAY);
// $router[] = new Route('<presenter>/<action>[/<id>]', 'Homepage:default');

// výchozí akcí bude presenter Homepage a pohled default
$container->router = new SimpleRouter('Homepage:default');

// $container->router = $router;

// Configure and run the application!
$container->application->run();
