<?php
use Nette\Utils\Strings,
	Nette\Image;

class FlashPlayerControl extends Nette\Application\UI\Control
{

	/** @var \Nette\Database\Table\Selection */
	private $video;


	public function __construct($video)
	{
		parent::__construct();
		$this->video = $video;
	}

	public function render()
	{

		$this->template->setFile(__DIR__ . '/FlashPlayer.latte');
		$this->template->video = $this->video;
		$this->template->videoPlaylist = $this->presenter->context->parameters['video'];
		$this->template->render();
	}


	public function handleChangeVideo($video)
	{	
		$this->video = $video;
		$this->template->video = $this->video;
		if (!$this->presenter->isAjax()) {
			$this->presenter->redirect('this');
		} else {
			$this->invalidateControl();
		}
	}
}