<?php

use Nette\Utils\Strings,
	Nette\Image;

class SlideShowControl extends Nette\Application\UI\Control
{

	/** @var \Nette\Database\Table\Selection */
	private $selected;

	public function __construct(Nette\Database\Table\Selection $selected)
	{
		parent::__construct();
		$this->selected = $selected;
	}

	public function render()
	{
		$this->template->setFile(__DIR__ . '/SlideShow.latte');
		$this->template->slides = $this->extractSlides();
		$this->template->render();
	}

	/**
	 * Create slider article variables
	 */

	public function extractSlides()
	{
		foreach ( $this->selected as $slideArticle)
		{
			$slides[] = array(
				'image' => $this->presenter->context->httpRequest->url->baseUrl . $this->presenter->context->parameters['images']['folder'] . $slideArticle->images,
				'article-id' => $slideArticle->id,
				'title' => $slideArticle->title
			);
		}

		return $slides;
	}
}