<?php

use Nette\Security,
	Nette\Utils\Strings;

/**
 * Users authenticator. The page will not be accesible for public.
 */
class Authenticator extends Nette\Object implements Security\IAuthenticator
{

	protected $user;
	protected $password;

	public function __construct(array $login)
	{
		
		$this->user = $login['user'];
		$this->password = $login['password'];

	}

	/**
	 * Performs an authentication.
	 * @return Nette\Security\Identity
	 * @throws Nette\Security\AuthenticationException
	 */
	public function authenticate(array $credentials)
	{
		list($username, $password) = $credentials;


		if ($username != $this->user) {
			throw new Security\AuthenticationException('The username is incorrect.', self::IDENTITY_NOT_FOUND);
		}

		if ($password != $this->password) {
			throw new Security\AuthenticationException('The password is incorrect.', self::INVALID_CREDENTIAL);
		}

		unset($configPassword);
		return new Security\Identity("1", NULL, array("user" => $username));
	}

}
