<?php
use Nette\Utils\Strings,
	Nette\Diagnostics;
/**
 * Base presenter for all application presenters.
 */
abstract class BasePresenter extends Nette\Application\UI\Presenter
{


	/** @var articlesRepository */
	private $articlesRepository;

	protected function startup()
	{
		parent::startup();

		$this->articlesRepository = $this->context->articlesRepository;
	}

	public function beforeRender()
	{	
		$this->template->pagename = $this->context->parameters['page']['pageName'];
		$this->template->adds = $this->context->parameters['adds'];
		$this->template->banners = $this->context->parameters['images']['banners'];
		$this->template->categories = $this->articlesRepository->getCategories();
		$this->template->newsTickers = $this->articlesRepository->findAllLimit(10,0);
	}


	protected function createComponentFlashPlayer()
	{

		return new FlashPlayerControl( $this->context->httpRequest->url->baseUrl . $this->context->parameters['video']['video1']['src']);
	}

	public function handleSignOut()
	{
		$this->getUser()->logout();
		$this->flashMessage('You have been signed out.');
		$this->redirect('in');
	}
}
