CREATE DATABASE IF NOT EXISTS kepler_news;
USE kepler_news;
DROP TABLE IF EXISTS `articles`;
CREATE TABLE `articles` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `guid` varchar(300) CHARACTER SET utf8 NOT NULL,
  `title` varchar(400) CHARACTER SET utf8 NOT NULL,
  `link` varchar(300) CHARACTER SET utf8 DEFAULT NULL,
  `category` varchar(200) CHARACTER SET utf8 DEFAULT NULL,
  `description` longtext CHARACTER SET utf8 NOT NULL,
  `images` longtext CHARACTER SET utf8 NOT NULL,
  `teaser` longtext CHARACTER SET utf8 NOT NULL,
  `body` longtext CHARACTER SET utf8 NOT NULL,
  `pub_date` datetime NOT NULL,
  PRIMARY KEY (`id`), 
  KEY `pud_date_idx` (`pub_date`),
  KEY `category_idx` (`category`),
  KEY `title_idx` (`title`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

SELECT * FROM `articles`;