<?php

include "config.php";

function extractParameters() {
	$parameters = array(
		"uuid" => createUuid(),
		"pagid" => createUuid(),
		"userid" => getUserID(),
		"thumb_delay" => getParameter("thumb_delay"),
		"thumb_delay_var" => getParameter("thumb_delay_var"),
		"jumpsize" => getParameter("jumpsize"),
		"jumpsize_var" => getParameter("jumpsize_var"),
		"photo_delay" => getParameter("photo_delay"),
		"photo_delay_var" => getParameter("photo_delay_var")
	);

	return $parameters;
}

function startsWith($string, $substring) {
	if (substr($string,0,strlen($substring))=='.') {
		return True;
	} else {
		return False;
	}
}

function getPreviousImage($folderPath, $imageFilename) {
	//Open the actual directorye

	$previous = "";

	if ($handle = opendir($folderPath)) {
		// Read all file from the actual directory
		while ($filename = readdir($handle))  {
			if (!startsWith($filename, '.') && isSupportedImage($filename)) {
				if ($filename == $imageFilename) {
					return $previous;
				}

				$previous = $filename;
			}
		}

		return "";
	}
}

function getNextImage($folderPath, $imageFilename) {
	//Open the actual directorye

	$stop = False;

	if ($handle = opendir($folderPath)) {
		// Read all file from the actual directory
		while ($filename = readdir($handle))  {
			if (!startsWith($filename, '.') && isSupportedImage($filename)) {
				if (!$stop) {
					if ($imageFilename == $filename) {
						$stop=True;
					}
				} else {
					return $filename;
				}
			}
		}

		return "";
	}
}

function getParameterString($parameters) {
	$parametersString = "";

	foreach (array_keys($parameters) as $key) {
		$parametersString = $parametersString."&".$key."=".$parameters[$key];
	}

	return 	$parametersString;
}

function createUuid() {
	if (function_exists('com_create_guid') === true) 	{
		return trim(com_create_guid(), '{}');
	}

	return sprintf('%04X%04X-%04X-%04X-%04X-%04X%04X%04X', mt_rand(0, 65535), mt_rand(0, 65535), mt_rand(0, 65535), mt_rand(16384, 20479), mt_rand(32768, 49151), mt_rand(0, 65535), mt_rand(0, 65535), mt_rand(0, 65535));
}

function getParameter($paramName) {
	if (isset($_GET[$paramName])) {
		return $_GET[$paramName];
	} else {
		return 0;
	}
}

function printDirnameIfExists($dirname) {
	global $image_base_path;

	if (is_dir($image_base_path.$dirname)) {
		print $dirname;
	} else {
		print "Unknown";
	}
}

function getAlbumName() {
	if (isset($_GET['album'])) {
		return $_GET['album'];
	} else {
		return "";
	}
}

function getUserID() {
	if (isset($_GET['userid'])) {
		return $_GET['userid'];
	} else {
		return "-1";
	}
}

function isSupportedImage($filePath) {
	$fileName = basename($filePath);
	$extName  = substr($fileName, strrpos($fileName, '.'), strlen($fileName));

	if (($extName == '.jpg') || ($extName == '.jpeg')|| ($extName == '.JPEG')|| ($extName == '.JPG')){
		return true;
	}
	return false;
}

function getImageWidth($image_file_path) {
	list($actual_image_width, $actual_image_height, $type, $attr) = getimagesize($image_file_path);
	return $actual_image_width;
}

function getImageHeight($image_file_path) {
	list($actual_image_width, $actual_image_height, $type, $attr) = getimagesize($image_file_path);
	return $actual_image_height;
}

function isImageHorizontal($image_file_path) {
	list($actual_image_width, $actual_image_height, $type, $attr) = getimagesize($image_file_path);
		
	if ($actual_image_width>$actual_image_height) {
		return true;
	} else {
		return false;
	}
}

function generateThumbnails(){
	global $thmb_width, $thmb_height;

	global $image_base_path;
	global $thumbnail_base_path;

	// Open the actual directory
	if ($handle = opendir($image_base_path)) {
		// Read all file from the actual directory

		while ($foldername = readdir($handle))  {
			if (!startsWith($foldername, '.')) {
				if ($handle2 = opendir($image_base_path.$foldername)) {
					while ($filename = readdir($handle2))  {
						$file = $image_base_path.$foldername."/".$filename;
						$thumbnail = $thumbnail_base_path.$filename;

						// Check whether the actual item is a valid file
						if (is_file($file)){
							// Check whether the actual image is a thumbnail
							if (is_file($thumbnail)){
								$isThumb = true;
							} else {
								$isThumb = false;
							}

							if (!$isThumb) {
								// Process the file string
								$dirName  = substr($file,0,strpos($file,basename($file)));
								if (strlen($dirName) < 1) $dirName = $image_base_path;
								$fileName = basename($file);
								$fileMain = substr($fileName,0,strrpos($fileName,'.'));
								$extName  = substr($fileName,strrpos($fileName,'.'),
								strlen($fileName)-strrpos($fileName,'.'));

								// Check if the actual file is a jpeg image
								if (isSupportedImage($file)){
									$thmbFile = $thumbnail_base_path.'/'.$fileMain.'.jpg';
									// If a thumbnail dosn't exists then create a new one
									if (!file_exists($thmbFile)){
										if (isImageHorizontal($filepath)) {
											$width = $thmb_width;
											$height = $thmb_height;
										} else {
											$height = $thmb_width;
											$width = $thmb_height;
										}
									
										imagejpeg(resizeImage($file,$width,$height), $thmbFile, 80);
									}
								}
							}
						}
					}
				}
			}
		}
	}
}

function generateThumbnail($album, $filename){
	global $thmb_width,$thmb_height;

	global $image_base_path;
	global $thumbnail_base_path;

	$folderPath = $image_base_path.$album;
	$filePath = $folderPath."/".$filename;

	$thumbnailFolderPath = $thumbnail_base_path.$album;

	if (!is_dir($thumbnailFolderPath)) {
		mkdir($thumbnailFolderPath);
	}

	$thumbnailFilePath = $thumbnailFolderPath."/".$filename;

	if (is_file($filePath)) {
		if (!is_file($thumbnailFilePath))  {
			if (isSupportedImage($filePath)){
				imagejpeg(resizeImage($filePath, $thmb_width, $thmb_height), $thumbnailFilePath,80);
			}
		}
	}
}


function resizeImage($originalImage, $toWidth, $toHeight){
	// Get the original geometry and calculate scales
	list($width, $height) = getimagesize($originalImage);
	
	$x = 0;
	
	if (isImageHorizontal($originalImage)) {
		$scale=$width/$toWidth;
		
		$new_width = round($width * (1/$scale));
		$new_height = round($height * (1/$scale));
		
		$y = 0;
	} else {
		$scale=$width/$toHeight;
		
		$new_width = round($height * (1/$scale));
		$new_height = round($width * (1/$scale));
		
		$cut = round($width * ($width / $height));
		
		$y = ($height - $cut) /2;
		$height = $cut;
	}

	// Resize the original image
	$imageResized = imagecreatetruecolor($new_width, $new_height);
	$imageTmp     = imagecreatefromjpeg ($originalImage);
	
	if (isImageHorizontal($originalImage)) {
		imagecopyresampled($imageResized, $imageTmp, 0, 0, $x, $y, $new_width, $new_height, $width, $height);
	} else {
		imagecopyresampled($imageResized, $imageTmp, 0, 0, $x, $y, $new_width, $new_height, $width, $height);
	}

	return $imageResized;
}

function getNormalImage($file){
	$base = substr($file,0,strrpos($file,'_th.jpg'));
	if (file_exists($base.'.jpg')) return $base.'.jpg';
	elseif (file_exists($base.'.jpeg')) return $base.'.jpeg';
	else return "";
}


function getFirstImageInFolder($folderPath) {
	//Open the actual directorye
	if ($handle = opendir($folderPath)) {
		// Read all file from the actual directory
		while ($filename = readdir($handle))  {
			if (!startsWith($filename, '.')) {
				if (isSupportedImage($filename)){
					return $file = $filename;
				}
			}
		}
	}
}

function getFilename() {
	if (isset($_GET['filename'])) {
		return $_GET['filename'];
	} else {
		return "Unknown photo";
	}
}

function printFilenameIfExists($album, $filename) {
	global $image_base_path;

	if (is_file($image_base_path.$album."/".$filename)) {
		print $filename;
	} else {
		print "Unknown photo";
	}
}

function displayPhotoAlbums(){
	global $columns;
	global $image_base_path;
	global $thumbnail_base_path;

	$thmb_width = 150;
	$thmb_height = 100;

	//$delay = $_GET['delay'];

	if (isset($_GET['delay'])) {
		$delay = $_GET['delay'];
	} else {
		$delay = 0;
	}

	if (isset($_GET['pause'])) {
		$pause = $_GET['pause'];
	} else {
		$pause = 0;
	}

	$parametersString = getParameterString(extractParameters());

	#generateThumbnails();
	$act = 0;

	// Open the actual directory
	if ($handle = opendir($image_base_path)) {
		// Read all folders from the actual directory
		while ($foldername = readdir($handle))  {
			if (!startsWith($foldername, '.')) {
				$firstFileInFolder = getFirstImageInFolder($image_base_path.$foldername."/");

				generateThumbnail($foldername, $firstFileInFolder);

				$thumbnail_file = $thumbnail_base_path.$foldername."/".$firstFileInFolder;
				++$act;
				if ($act > $columns) {
					echo '</tr><tr>';
					$act = 1;
				}

				echo
				'<td class="thumb" width="'.$thmb_width.'" height="'.$thmb_height.'" class="photo">
					<div class="album_img" style="height:'.$thmb_height.'px">
						<a href="album.php?'.$parametersString.'&album='.$foldername.'">
							<img class="thumbnail" width="'.$thmb_width.'" height="'.$thmb_height.'" src2="./res/loader.gif" title="'.$thumbnail_file.'"/>
						</a>
					</div>
					<center><p>'.$foldername.'</p></center>
				</td>';    
			}
		}
	}
}


function displayPhotos(){
	global $columns;
	global $image_base_path;
	global $thumbnail_base_path;

	$thmb_width = 150;
	$thmb_height = 100;

	//$delay = $_GET['delay'];

	if (isset($_GET['delay'])) {
		$delay = $_GET['delay'];
	} else {
		$delay = 0;
	}

	$album = getAlbumName();

	if ($album =="") {
		echo "<center><h1>Unkonwn album!<h1></center>";
		return;
	} else {
		if (!is_dir($image_base_path.$album)) {
			#echo "<center><h1>Unkonwn album!<h1></center>";
			return;
		}
	}

	#generateThumbnails();
	$act = 0;

	$base_path = $image_base_path.$album."/";

	$parametersString = getParameterString(extractParameters());

	// Open the actual directory
	if ($handle = opendir($base_path)) {
		// Read all file from the actual directory
		while ($filename = readdir($handle))  {
			$file = $base_path.$filename;
			$thumbnail_file = $thumbnail_base_path.$album."/".$filename;

			// Check whether the actual item is a valid file
			if (is_file($file)){
				if (isSupportedImage($file)) {
					generateThumbnail($album, $filename);

					++$act;
					if ($act > $columns) {
						echo '</tr><tr>';
						$act = 1;
					}

					echo '<td class="thumb" width="'.$thmb_width.'" height="'.$thmb_height.'" class="photo">
						<div class="photo_img" style="height:'.$thmb_height.'px">
                    		<a href="view_photo.php?'.$parametersString.'&album='.$album.'&filename='.$filename.'&type=p">
		   					<img class="thumbnail" width="'.$thmb_width.'" height="'.$thmb_height.'" src2="./res/loader.gif" title="'.$thumbnail_file.'"/>
		   					</a>
		   				</div>
		   			</td>';    
				}
			}
		}
	}
}

function displayPhoto(){
	global $image_base_path;
	global $image_height;
	global $image_width;

	if (isset($_GET['album'])) {
		$album = $_GET['album'];
	} else {
		echo '<tr><td>Unknown photo!!</td></tr>';
		return;
	}

	$filename = getFilename();
	$filepath = $image_base_path.$album."/".$filename;

	$parametersString="";

	// Check whether tha actual item is a valid file
	if (is_file($filepath)) {
		$previousImage = getPreviousImage($image_base_path.$album, $filename);
		$nextImage = getNextImage($image_base_path.$album, $filename);

		$parametersString = getParameterString(extractParameters());

		if (isImageHorizontal($filepath)) {
			$width = getImageWidth($filepath);
			$height = getImageHeight($filepath);
			
			if ($width > $image_width) {
				$width = $image_width;
			}
		} else {
			$width = getImageWidth($filepath);
			
			if ($width > $image_height) {
				$width = $image_height;
			}
		}
		
		echo '<td>
					<div class="photo_navigate_back_to_album">';
		echo '			<a id="link" href="album.php?'.$parametersString.'&album='.$album.'">Zur&uuml;ck zu '.$album.'</a>';
		echo '		</div>
			  </td>';
		
		echo '<td>
					<div class="photo_navigate_links">';
		
		if ($previousImage != "") {
			echo '		<a id="link" href="view_photo.php?'.$parametersString.'&album='.$album.'&filename='.$previousImage.'&type=p">Zur&uuml;ck</a>';
		}

		if ($nextImage != "") {
			echo '		<a id="link" href="view_photo.php?'.$parametersString.'&album='.$album.'&filename='.$nextImage.'&type=p">Weiter</a>';
		}
		
		echo '		</div>
			</td>';
		
		echo '<tr>
				<th colspan="2" class="photo" align="center" width="'.$width.'" height="'.$height.'">';

		if ($nextImage != "") {
			echo '<a class="photo_navigation_link" href="view_photo.php?'.$parametersString.'&album='.$album.'&filename='.$nextImage.'&type=p">';
		} else {
			echo '<a class="photo_navigation_link" href="album.php?'.$parametersString.'&album='.$album.'">';;		
		}

		echo '<img id="photo" width="'.$width.'" height="'.$height.'" title="'.$filepath.'"/>';

		if ($nextImage != "") {
			echo '</a>';
		}

		echo '	</th>
		</tr>';
	}
}

function displayPhotoCommentForm() {
	$parametersString = getParameterString(extractParameters());
	$filename = getFilename();
	$album = getAlbumName();;

	echo '
	<form action="view_photo.php?'.$parametersString.'&album='.$album.'&filename='.$filename.'&type=p" method="post">
		<td class="comment_td">
			<textarea name="comment" cols="53" rows="3"></textarea>

		</td></tr>
		<tr>
		<td class="comment_td">
			<input type="submit" name="send_comment" value="         Comment         ">
		</td>
	</form>
	';
}

function writeCommentToFile($album, $filename, $comment) {
	global $image_base_path;

	$filepath = $image_base_path.$album."/".$filename;

	$userid = getUserID();

	#$comment = preg_replace( '/\r\n/', '<br>', $comment);
	#$comment = str_replace( '\r\n/', '&#13;&#10;', $comment);

	$comment = htmlentities($comment);

	$dom_document = new DOMDocument('1.0');

	if (file_exists($filepath)) {
		$dom_document->load($filepath);

		$dom_root_element = $dom_document->documentElement;
	} else {
		#$xml = new SimpleXMLElement('<comments></comments>');
		$dom_root_element = $dom_document->createElement('comments');
		$dom_document->appendChild($dom_root_element);
	}

	$dom_node_new = $dom_document->createElement("comment");
	$dom_root_element->appendChild($dom_node_new);


	$dom_node_new->setAttribute("userid", getUserID());
	$dom_node_new->setAttribute("datetime", date("d.m.Y G:i"));
	$dom_node_new_comment = $dom_document->createTextNode($comment);
	$dom_node_new->appendChild($dom_node_new_comment);


	$dom_document->save($filepath);
}

function displayPhotoComments() {
	global $image_base_path;

	$filename = getFilename().".xml";
	$album = getAlbumName();
	$filepath = $image_base_path.$album."/".$filename;

	if (file_exists($filepath)) {
		$xml = simplexml_load_file($filepath);

		echo '
		<td>
		<br>
		';

		foreach($xml->children() as $child) {
			$comment = preg_replace( '/\r\n/', '<br>', $child);

			if (strstr($comment, "\r\n")) {
				print "yess";
			}

			echo '<div id="comment">
					User-ID: ' . $child["userid"] . ", ";
			echo "Date: " . $child["datetime"] . "<br>".
			$comment .
			"</div>
			";
		}

		echo '
		</td>
		';
	}
}

function displayDivTags() {
	print
		'
		<div id="wrap">
		<div id="fakebookHeader"></div>
		<div id="fakebookLeftSidebar"></div>
		<div id="fakebookContent"></div>
		<!-- <div id="fakebookRightSidebar"></div> -->
		</div>
		';
}

function displayHeader() {
	$header = '
	<div id="fakebookHeader">
	<table class="header_table">
		<tr>
			<td>
				<div>
					<span><font id="fakebookHeaderText">My Social Picture Gallery</font></span>
			    	<img id="status_indicators" src="res/status_indicators.png" style="vertical-align: bottom;"/>
				</div>
			</td>
			<td>
		    	<img id="status_indicators" src="res/searchbox.gif" style="vertical-align: bottom;"/>
	    		
		    	<span"><font class="fakebookSubHeaderFirstItem">Home</font></span>
		    	<span"><font class="fakebookSubHeaderText">Profile</font></span>
		    	<span"><font class="fakebookSubHeaderText">Account</span>
		    	
			</td>
		<tr>
	</table>
	</div>
	';

	echo $header;
}

function displayLeftSidebar() {
	$album_overview = "index.php?" . getParameterString(extractParameters());

	$max_friends_in_sidebar = 6;
	
	$header = '
	<div id="fakebookLeftSidebar">
		<div id="sidebar_avatar_image">
			<img width="200px" class="sidebar_image" src="res/avatar.jpg" style="vertical-align: middle;"/>
		</div>
		<div id="sidebar_entry">
	    	<img id="sidebar_icon" src="res/wall.gif" style="vertical-align: middle;"/>
	    	<span style="vertical-align: middle;"><font class="sidebar_entry_text">Wall</font></span>
		</div>
		<div id="sidebar_icon" id="sidebar_entry">
	    	<img src="res/info.gif" style="vertical-align: middle;"/>
	    	<span style="vertical-align: middle;"><font class="sidebar_entry_text">Info</font></span>
		</div>
		<div id="sidebar_entry">
	    	<img id="sidebar_icon" src="res/photos.gif" style="vertical-align: middle;"/>
	    	<span style="vertical-align: middle;"><a id="sidebar_link" href="'.$album_overview.'"><font class="sidebar_entry_text">Photos</font></a></span>
		</div>
		<div id="sidebar_entry">
	    	<img id="sidebar_icon"src="res/friends.gif" style="vertical-align: middle;"/>
	    	<span style="vertical-align: middle;"><font class="sidebar_entry_text">Friends</font></span>
		</div>
		<div id="sidebar_friends_section_entry">
	    	<font class="sidebar_link">Friends ('.$max_friends_in_sidebar.')</font>
		</div>';
	
	
	
	for ($x = 0; $x<$max_friends_in_sidebar; $x++) {
		$header .= '
		<div id="sidebar_friend_entry">
	    	<img class="sidebar_avatar"src="res/small_avatar.gif" style="vertical-align: middle;"/>
	    	<span style="vertical-align: middle;"><font class="sidebar_entry_text">Friend '.$x.'</font></span>
		</div>';
	}
		
	$header .='</div>
	';

	echo $header;
}

function displayRightSidebar() {
	$header = '
	<div id="fakebookRightSidebar">
	<p>Friends:</p>
	<ul>
	<li>Marilyn</li>
	<li>Mojo</li>
	<li>Deathstars</li>
	</ul>
	</div>
	';

	echo $header;
}

?>